/******************************************************************************

SOFTING AG
Richard-Reitzner-Allee 6
D-85540 Haar
Phone: ++49-89-4 56 56-0
Fax: ++49-89-4 56 56-3 99
http://www.softing.com

Copyright (C) SOFTING AG 2000-2003, All Rights Reserved

Version: 1.12.0.00.release

******************************************************************************/
/*
*/


#include "basetypes.h"

#include <linux/types.h>
//#include <linux/devfs_fs_kernel.h>
#include <linux/proc_fs.h>

#include <linux/interrupt.h>
#include <linux/init.h>
#include <linux/pci.h>

#include <linux/version.h>

#include <linux/delay.h>

#include "kernel_version.h"

#include "cntrl.h"

#include <linux/errno.h>

//#include <asm/spinlock.h>

#include <linux/spinlock.h>

#include "bootV311.h"






/******************************************************************************
DEFINES
******************************************************************************/

#undef THIS_FILE_ID
#define THIS_FILE_ID                HW_FILE_ID

//---------------------------------------------------------------------------+/




/******************************************************************************
FUNCTION DECLARATION
******************************************************************************/

int hw_upgrade_start(struct CntrlExt   *Board);
int hw_upgrade_firmware_V311(struct CntrlExt *Board, USIGN16 Length, USIGN32 Address,USIGN8 *pSbnRecord);
void hw_upgrade_stop(struct CntrlExt   *Board);
int PbInitBoard( struct CntrlExt *Board, char Reset );



//---------------------------------------------------------------------------+/


/******************************************************************************
GLOBAL_DATA
******************************************************************************/

/******************************************************************************
LOCAL_DATA
******************************************************************************/

//extern  T_HW_CO             HwObject [MAX_NUMBER_CHANNELS];


/******************************************************************************
MODULE FUNCTION
******************************************************************************/


//===========================================================================+/

// wandelt Versionsstring in Versionsnummer
USIGN32 GetBootblockVersion(unsigned char *pVersionLocation)
{ // 3.00.0.1 ==> 0x03000001
  unsigned char *pTok;
  USIGN32 version=0, sub=0;
  
 
  pTok = pVersionLocation + 0x15;
  sscanf(pTok,"%x",&version);
  while(*pTok++ != '.') ;   
  sscanf(pTok,"%x",&sub); 
  version = (version << 24) | (sub << 16);  
  while(*pTok++ != '.') ; 
  sscanf(pTok,"%x",&sub); 
  version |= (sub << 8);  
  while(*pTok++ != '.') ;  
  sscanf(pTok,"%x",&sub); 
  version |= sub;
      
  return version;
  
  
}

void PbGetFwVersion(char *pDpram, USIGN32 *pVersion, USIGN32 *pSubversion)
{
  char *pDigit;
  T_V311_HOST_SHARED_MEMORY  *pHwObject = (T_V311_HOST_SHARED_MEMORY*)pDpram;
  
  
  pDigit = (unsigned char*)&pHwObject->BootIfDescr.BootLoaderVersion;
  
  *pVersion = (pDigit[1]-'0')*100+(pDigit[2]-'0')*10+pDigit[3]-'0';
  
  *pSubversion = GetBootblockVersion((unsigned char*)&pHwObject->BootIfDescr.BootLoaderVersion);
   
  return;
}



char *pGetFwVersionString_V311(char *pDpram)
{
  T_V311_HOST_SHARED_MEMORY *    pHostSharedMemory;
  
  pHostSharedMemory = (T_V311_HOST_SHARED_MEMORY *) pDpram;
  
  return pHostSharedMemory->BootIfDescr.FirmwareVersionString;
}

/*===========================================================================*/

//#define HEADERSIZE 8



int CheckRecord (T_SBN_HEADER_DESCR *FwRecord)
{
  unsigned int i;
  T_SBN_HEADER_DESCR *Record=FwRecord;
  unsigned short u16CheckSum=0;

	
  for (i=0; i<(Record->Struct.Length+sizeof(Record->Struct)); i++)
    u16CheckSum+=Record->Raw[i];
  
 // printk("CheckRecord: 0x%x, 0x%x\n",u16CheckSum, *(unsigned short *)(&(Record->Raw[Record->Struct.Length+sizeof(Record->Struct)])));
  
  return (u16CheckSum != *(unsigned short *)(&(Record->Raw[Record->Struct.Length+sizeof(Record->Struct)])))?-1:0;
}


int boot_handle_sbn_record(struct CntrlExt *Board, const char *pBuffer, int size)
    /*-------------------------------------------------------------------------*/
{
  int                   rest;
  int                   RetCode=0;
  int                   RecordError;
  T_SBN_HEADER_DESCR    *pRecord;
  
  
  rest = size;
  // printk("boot_read_sbn_record: buffer ptr: 0x%x\n", Board->fwBufferPtr);
  
  
  pRecord = (T_SBN_HEADER_DESCR *)pBuffer;
  
  while(rest > 0)
  {
   
    
    if(Board->fwBufferPtr)
    { // last record was not a complete record!
      
     // printk("boot_read_sbn_record: BufferPtr=0x%x\n", Board->fwBufferPtr);
      
      pRecord = (T_SBN_HEADER_DESCR *)Board->SbnBuffer;
      
      if((pRecord->Struct.Length - Board->fwBufferPtr + 2 + sizeof(pRecord->Struct)) <= rest)
      {
       // printk("copy %u Bytes\n", pRecord->Struct.Length - Board->fwBufferPtr + 2 + sizeof(pRecord->Struct));
        memcpy(&Board->SbnBuffer[Board->fwBufferPtr], pBuffer, pRecord->Struct.Length - Board->fwBufferPtr + 2 + sizeof(pRecord->Struct));
      }
      else
      {
        memcpy(&Board->SbnBuffer[Board->fwBufferPtr], pBuffer, rest);
        Board->fwBufferPtr += rest;
        return 0;
        
      }
            
    }
    
    if(pRecord->Struct.Length > MAX_SBNRECORD_SIZE)
    {
      printk ("sbn exceeds max. sbn record size rest=0x%x, Len=0x%x\n", rest, pRecord->Struct.Length);
      
     // DumpMem(pBuffer,0x200,"Buffer");
     // DumpMem(pRecord,0x100,"Record");
      Board->fwBufferPtr = 0;
      return -1;
    }
    
    if ((pRecord->Struct.Length  + 2 + sizeof(pRecord->Struct) > rest) && (!Board->fwBufferPtr))
    {
      /*
      printk ("not a full record! rest=%li, Len=%u\n", rest, pRecord->Struct.Length);
      
      printk("Sbn Record Type=%u, Length=%u, Address=0x%lx Checksum=0x%x restLen=%lu\n",
             pRecord->Struct.Type, 
             pRecord->Struct.Length, 
             pRecord->Struct.Address, 
             *(unsigned short*)&(pRecord->Raw[pRecord->Struct.Length]),
             rest
            ); 
      */
         
      memcpy(&Board->SbnBuffer[Board->fwBufferPtr], pRecord, rest);
      Board->fwBufferPtr += rest;
      return 0;
      
    }
    else
    {
      /*
      printk("Sbn Record Type=%u, Length=%u, Address=0x%lx Checksum=0x%x restLen=%lu\n",
             pRecord->Struct.Type, 
             pRecord->Struct.Length, 
             pRecord->Struct.Address, 
             *(unsigned short*)&(pRecord->Raw[pRecord->Struct.Length]),
             rest
            );    
      */
    }
    

    RecordError = CheckRecord(pRecord);
        
    if(RecordError)
    {
      printk ("checksum error in sbn record\n");
    }
    else
    {
     // printk ("checksum ok in sbn record\n");
    }
    
    
    switch(pRecord->Struct.Type)
    {
      case SBNDATA:
        RetCode = hw_upgrade_firmware_V311(Board, pRecord->Struct.Length, pRecord->Struct.Address, &pRecord->Raw[sizeof(pRecord->Struct)]);
        break;
        
      case SBNSTART:
        // wird weggeworfen, da Applikation immer an der gleichen Stelle startet.
        break;
        
      case SBNEOF:
        hw_upgrade_stop(Board);
        RetCode = 0;
        break;
        
      case SBNSTRING:
        RetCode = hw_upgrade_start(Board);
        break;
        
      default:   
        printk("unknown record type!\n");    
        break;
      
    }
        
    if(RetCode)
    {
      printk("Error occurred while downloading! Error:0x%x\n",RetCode);
      return RetCode;
      
    }
    
    
    if(Board->fwBufferPtr)
    {
      rest = rest - pRecord->Struct.Length - sizeof(pRecord->Struct) - 2 + Board->fwBufferPtr;
      pRecord = (T_SBN_HEADER_DESCR *)&pBuffer[pRecord->Struct.Length - Board->fwBufferPtr + 2 + sizeof(pRecord->Struct)];
    }
    else
    {
      rest = rest - pRecord->Struct.Length - sizeof(pRecord->Struct) - 2;
      pRecord = (T_SBN_HEADER_DESCR *)&pRecord->Raw[pRecord->Struct.Length+sizeof(pRecord->Struct) + 2];
    }
    
    Board->fwBufferPtr = 0;
  

  }


  return 0;
}



//===========================================================================+/

void hw_upgrade_stop
    (
    IN    struct CntrlExt   *Board 
    )
    //-------------------------------------------------------------------------+/
{
  T_V311_HOST_SHARED_MEMORY *       pHostSharedMemory;
  USIGN32                           PollingCounter;
  char * pDpram = (unsigned char*) Board->DprAddr;


 // printk ("hw_upgrade_stop");


  if (pDpram == 0)
  {
    return;
  }

  pHostSharedMemory = (T_V311_HOST_SHARED_MEMORY *) pDpram;
  pHostSharedMemory->BootIfDescr.BootLoaderMask = 0uL;

  PbInitBoard( Board, 0 );
  PbInitBoard( Board, C165_RESET );
    
  PollingCounter = 0;

  do
  {
    msleep (TYP_START_FIRMWARE_ACK_TIME);

    PollingCounter += TYP_START_FIRMWARE_ACK_TIME;

    if (PollingCounter > MAX_START_FIRMWARE_ACK_TIME)
    {
      PbInitBoard( Board, 0 );
      return;
    }

  } while ( _CONVERT_USIGN32_TO_HOST_BYTE_ORDERING ( pHostSharedMemory->BootIfDescr.BootLoaderMask) != BOOT_BLOCK_EXIST );

    
  PbInitBoard( Board, 0 );
  



  msleep (200);
}


int hw_upgrade_firmware_V311
    (
    IN    struct CntrlExt   *Board, 
    IN    USIGN16           Length,
    IN    USIGN32           Address,
    IN    USIGN8 *          pSbnRecord
    )
    //-------------------------------------------------------------------------+/
{
  T_V311_BOOT_HOST_SHARED_MEMORY *    pHostSharedMemory;
  USIGN32                           PollingCounter;
  char * pDPRAM = (char*)Board->DprAddr;


  if (pDPRAM == NULL)
  {
    return (-1);
  }

  pHostSharedMemory = (T_V311_HOST_SHARED_MEMORY *) pDPRAM;
  
  pHostSharedMemory->ServiceReq.ReturnCode = BOOTIF_OK; // initializing

  pHostSharedMemory->ServiceReq.UseAs.ProgramFlash.Type  =
      _CONVERT_USIGN16_TO_CONTROLLER_BYTE_ORDERING ( TYPE_PROGRAM_DATA);

  pHostSharedMemory->ServiceReq.UseAs.ProgramFlash.Length =
      _CONVERT_USIGN32_TO_CONTROLLER_BYTE_ORDERING ( Length);

  pHostSharedMemory->ServiceReq.UseAs.ProgramFlash.Offset =
      _CONVERT_USIGN32_TO_CONTROLLER_BYTE_ORDERING ( Address);

  memcpy (pHostSharedMemory->ServiceReq.UseAs.ProgramFlash.BinaryData, pSbnRecord, Length);

  // DumpMem(pHostSharedMemory, 0x200, "DPRAM");
  
  pHostSharedMemory->BootIfDescr.SignalFromHost =
      _CONVERT_USIGN16_TO_CONTROLLER_BYTE_ORDERING (BOOTIF_SIGNAL_SERVICE_PROGRAM_FLASH);

  //--- wait for Signal Acknowledge -------------------------------------+/

  PollingCounter = 0;

  do
  {
    msleep (TYP_BOOTIF_SIGNAL_ACK_TIME*4);

    PollingCounter += TYP_BOOTIF_SIGNAL_ACK_TIME;

    if (PollingCounter > MAX_BOOTIF_SIGNAL_ACK_TIME)
    {
      hw_upgrade_stop (Board);
      printk ("bootblock not responding");
      return (BOOT_ERR_NO_CONTROLLER_SIGNAL_ACK);
    }

  } while ( _CONVERT_USIGN16_TO_HOST_BYTE_ORDERING ( pHostSharedMemory->BootIfDescr.SignalFromHost) != BOOTIF_SIGNAL_ACKNOWLEDGE );

  //--- check service return code --------------------------------------+/

  switch (_CONVERT_USIGN16_TO_HOST_BYTE_ORDERING ( pHostSharedMemory->ServiceReq.ReturnCode))
  {
    case BOOTIF_OK                     : 
      break;
    case BOOTIF_ERROR_INVALID_LENGTH   : 
      printk ("invalid record length"); 
      // DumpMem(pHostSharedMemory, 0x200, "DPRAM");
      return (BOOT_ERR_INVALID_LENGTH);
      
    case BOOTIF_ERROR_INVALID_OFFSET   : 
      printk ("invalid record offset"); 
      // DumpMem(pHostSharedMemory, 0x200, "DPRAM");
      return (BOOT_ERR_INVALID_OFFSET);
      
    case BOOTIF_ERROR_FLASH_ERASE_ERROR: 
      printk ("flash erase error"); 
      // DumpMem(pHostSharedMemory, 0x200, "DPRAM");
      return (BOOT_ERR_FLASH_ERASE_ERROR);
      
    case BOOTIF_ERROR_FLASH_WRITE_ERROR: 
      printk ("flash write error"); 
      // DumpMem(pHostSharedMemory, 0x200, "DPRAM");
      return (BOOT_ERR_FLASH_WRITE_ERROR);

    default: 
      // DumpMem(pHostSharedMemory, 0x200, "DPRAM");
      return (PSAK_ERR_CHANNEL_NOT_IN_USE);
  }

  return (BOOTIF_OK);
}

int hw_upgrade_start
    (
    IN    struct CntrlExt   *Board
    )
    //-------------------------------------------------------------------------+/
{
  T_V311_BOOT_HOST_SHARED_MEMORY *    pHostSharedMemory;
  
  USIGN32                           PollingCounter;

 // printk ("hw_upgrade_start");

 
  if (Board->DprAddr == 0)
  {
    return (PSAK_ERR_CHANNEL_NOT_IN_USE);
  }

  pHostSharedMemory = (T_V311_BOOT_HOST_SHARED_MEMORY *) Board->DprAddr;
  pHostSharedMemory->BootIfDescr.BootLoaderMask = 0uL;
  
  

  PbInitBoard( Board, 0 );
  msleep (200);
  PbInitBoard( Board, C165_RESET );


  PollingCounter = 0;

  do
  {

    msleep (TYP_START_FIRMWARE_ACK_TIME*4);

    PollingCounter += TYP_START_FIRMWARE_ACK_TIME;

    if (PollingCounter > MAX_START_FIRMWARE_ACK_TIME)
    {
      PbInitBoard( Board, 0 );
      
      printk ("bootblock does not exist or not responding\n");
      
      return (BOOT_ERR_BOOTBLOCK_NOT_EXIST);
    }

  } while ( _CONVERT_USIGN32_TO_HOST_BYTE_ORDERING ( pHostSharedMemory->BootIfDescr.BootLoaderMask) != BOOT_BLOCK_EXIST );

  
  
  
  if ( (pHostSharedMemory->BootIfDescr.BootLoaderVersion != BOOT_BLOCK_VERSION_V200) &&
        (pHostSharedMemory->BootIfDescr.BootLoaderVersion != BOOT_BLOCK_VERSION_V250) )
  {
    printk ("bootblock version does not support firmware upgrade\n");

    return (PSAK_ERR_INTERFACE_VERSION_CONFLICT);
  }
  
  
 
  /*
  printk ("hw_upgrade_start: firmware version:%s\n", 
          pGetFwVersionString_V311((char*)Board->DprAddr)
         );
  */
  

  pHostSharedMemory->BootIfDescr.HostBootSelectMask = _CONVERT_USIGN32_TO_CONTROLLER_BYTE_ORDERING ( START_BOOTBLOCK_FIRMWARE);

  return (BOOT_OK);
}
