/*****************************************************************************/
/*                                                                           */
/*                              SOFTING AG                                   */
/*                        Richard-Reitzner-Allee 6                           */
/*                              D-85540 Haar                                 */
/*                      Phone: (++49)-(0)89-45656-0                          */
/*                      Fax:   (++49)-(0)89-45656-399                        */
/*                                                                           */
/*                  Copyright (C) SOFTING AG 1995-2004                       */
/*                                                                           */
/* See file CREDITS for list of people who contributed to this               */
/* project.                                                                  */
/*                                                                           */
/* This program is free software; you can redistribute it and/or             */
/* modify it under the terms of the GNU General Public License as            */
/* published by the Free Software Foundation; either version 2 of            */
/* the License, or (at your option) any later version.                       */
/*                                                                           */
/* This program is distributed in the hope that it will be useful,           */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston,                    */
/* MA 02111-1307, USA.                                                       */
/*                                                                           */
/* email: support.automation@softing.com                                     */
/* Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany                 */
/*                                                                           */
/*****************************************************************************/
/*****************************************************************************/
/*                                                                           */
/*  Author      : SOFTING                                                    */
/*                                                                           */
/*  CHANGE_NOTES                                                             */
/*                                                                           */
/*  date      name      change                                               */
/*  -----------------------------------------------------------------------  */
/*****************************************************************************/
/*****************************************************************************/

#ifndef PB_DEBUG_H
#define PB_DEBUG_H

#define D_BOARD_L1   0x00010001
#define D_BOARD_L2   0x00010002
#define D_BOARD_L3   0x00010003
#define D_SERVICE_L1 0x00020001
#define D_SERVICE_L2 0x00020002
#define D_SERVICE_L3 0x00020004
#define D_DATA_L1    0x00040001
#define D_DATA_L2    0x00040002
#define D_DATA_L3    0x00040004
#define D_SLAVE_L1   0x00080001
#define D_SLAVE_L2   0x00080002
#define D_SLAVE_L3   0x00080003
#define D_CMI_L1     0x00100001
#define D_CMI_L2     0x00100002
#define D_CMI_L3     0x00100003
#define D_FW_L1      0x00200001
#define D_FW_L2      0x00200002
#define D_FW_L3      0x00200003
#define D_OTHER_L1   0x00400001
#define D_OTHER_L2   0x00400002
#define D_OTHER_L3   0x00400004
#define D_ALL_L1     (  D_BOARD_L1   |\
            D_SERVICE_L1 |\
            D_SLAVE_L1   |\
            D_DATA_L1    |\
            D_CMI_L1     |\
              D_FW_L1)

#define MAX_DEBUG_CNTRL_LEN  30

#define PRE_DEBUG_STRING "debug "

#ifdef DEBUG
extern unsigned int DebugArea;
extern void DebugOut( unsigned int area, char *fmt, ... );
extern void (*DebugFnctn )( unsigned int, char *fmt, ... );
extern int GetDebugFromString( char *DebugCmd );

#define PR_DEBUG(area,fmt,arg...) \
                if( DebugArea )\
                  DebugFnctn( area, fmt, ##arg )
#else
#define PR_DEBUG(area,fmt,arg...)
#endif

#endif
